<template>
  <div>
    <p style="color: red;">{{ error }}</p>

    <Loading :loading="this.$apollo.queries.stats.loading" />

    <h1>Stats</h1>
    <i>Stats are not yet complete...</i>

    <br />
    <br />

    <h2>Shields</h2>

    <b-row v-for="shield in shields" v-bind:key="shield.prefix">
      <b-col>
        <img
          :src="
            dynamicShield(
              shield.color,
              shield.query,
              shield.graphql,
              shield.prefix
            )
          "
        />
      </b-col>
      <b-col md="9">
        <pre>{{
          markdownShield(
            dynamicShield(
              shield.color,
              shield.query,
              shield.graphql,
              shield.prefix
            )
          )
        }}</pre>
      </b-col>
    </b-row>

    <h2>Chart demo</h2>
    <LineChart
      v-if="!this.$apollo.queries.stats.loading"
      :chartdata="linechartdata"
    />
    <PieChart
      v-if="!this.$apollo.queries.stats.loading"
      :chartdata="piechartdata"
    />

    <h2>Users</h2>
    <p>total: {{ stats.users.count }}</p>

    <p>{{ stats }}</p>
  </div>
</template>

<script>
import LineChart from "@/components/charts/Line.vue";
import PieChart from "@/components/charts/Pie.vue";
import Loading from "@/components/Loading.vue";
import gql from "graphql-tag";

export default {
  name: "Stats",
  methods: {
    markdownShield: (
      shield,
      alt = process.env.VUE_APP_TITLE,
      link = process.env.VUE_APP_FRONTEND_URL
    ) => `[![${alt}](${shield})](${link})`,
    dynamicShield: (color, query, graphql, prefix) =>
      `https://img.shields.io/badge/dynamic/json?label=${encodeURIComponent(
        process.env.VUE_APP_TITLE
      )}&color=${encodeURIComponent(color)}&prefix=${encodeURIComponent(
        prefix
      )}&query=${encodeURIComponent(query)}&url=${encodeURIComponent(
        process.env.VUE_APP_APIURL + "?query=" + encodeURIComponent(graphql)
      )}`
  },
  data() {
    return {
      error: "",
      shields: [
        {
          color: "green",
          query: "$.data.stats.users.total",
          graphql: "{stats {users {total}}}",
          prefix: "users: "
        },
        {
          color: "green",
          query: "$.data.stats.builds.total",
          graphql: "{stats {builds {total}}}",
          prefix: "builds: "
        }
      ],
      stats: { users: { count: "" } },
      linechartdata: {
        labels: ["January", "February", "March"],
        datasets: [
          {
            label: "Data One",
            backgroundColor: "green",
            borderColor: "lightgreen",
            fill: false,
            data: [40, 20, 25]
          },
          {
            label: "Data Two",
            data: [10, 55, 30],
            backgroundColor: "lightblue",
            type: "bar"
          }
        ]
      },
      piechartdata: {
        labels: ["PASS", "WONKY", "FAIL", "INCONCLUSIVE"],
        datasets: [
          {
            label: "Data One",
            backgroundColor: ["green", "yellow", "red", "lightgrey"],
            data: [40, 10, 25, 10]
          }
        ]
      }
    };
  },
  components: {
    LineChart,
    PieChart,
    Loading
  },
  apollo: {
    stats: {
      query: gql`
        query stats {
          stats {
            users {
              total
            }
          }
        }
      `,
      error(error) {
        this.error = error;
      }
    }
  }
};
</script>
